<template>
  <div class="modificar">
    <!--Formulario de búsqueda-->
    <div class="container">
      <div class="row">
        <div class="h2 titulo"> {{ titulo }} </div>
      </div>

      <!--Botones de  búsqueda-->
            <div class="row">
                <div class="btn-group btn-group-toggle" data-toggle="buttons">
                    <button type="button" class="btn btn-info" @click="formSucursal">
                        <input type="radio" name="options" id="option1" v-model="selectSucursal"> Sucursal
                    </button>
                    <button type="button" class="btn btn-info" @click="formRegional">
                        <input type="radio" name="options" id="option1" v-model="selectRegional"> Regional
                    </button>
                </div>
            </div>

            <!--Formulario de búsqueda por sucursal-->
                <form v-if="selectSucursal === true">
                <div class="form-row mt-3">
                    <div class="form-group col-md-6">
                        <label for="fecha_1">Fecha Inicio: </label>
                        <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                        <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                        *Campo requerido.
                        </small>
                    </div>
                    <div class="form-group col-md-3">
                        <label for="fecha_2">Fecha fin: </label>
                        <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                        <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                        *Campo requerido.
                        </small>
                    </div>
                    <div class="form-group col-md-3">
                        <label for="sucursal">Sucursal: </label>
                        <select class="custom-select" name="sucursal2" id="sucursal" v-model="sucursal">
                        <option selected></option>
                            <option value="xalapa">Xalapa</option>
                            <option value="teziutlan">Teziutlán</option>
                            <option value="oaxaca">Oaxaca</option>
                            <option value="puebla">Puebla</option>
                            <option value="huamantla">Huamantla</option>
                        </select>
                        <small id="demo" class="form-text text-danger" v-if="!sucursal">
                        *Campo requerido.
                        </small>
                    </div>
                </div>

                <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaSucursal">Buscar</button>
            </form>

            <!--Formulario de búsqueda por regional-->
            <form v-if="selectRegional === true">
                <div class="form-row mt-3">
                    <div class="form-group col-md-6">
                        <label for="fecha_1">Fecha Inicio: </label>
                        <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                        <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                        *Campo requerido.
                        </small>
                    </div>
                    <div class="form-group col-md-3">
                        <label for="fecha_2">Fecha fin: </label>
                        <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                        <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                        *Campo requerido.
                        </small>
                    </div>
                    <div class="form-group col-md-3">
                        <label for="regional">Regional: </label>
                        <select class="custom-select" name="regional" id="regional" v-model="regional">
                            <option selected></option>
                            <option value="veracruz">Veracruz</option>
                            <option value="oaxaca">Oaxaca</option>
                            <option value="puebla">Puebla</option>
                        </select>
                        <small id="demo" class="form-text text-danger" v-if="!regional">
                            *Campo requerido.
                        </small>
                    </div>
                </div>

                <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaRegional">Buscar</button>
            </form>

      <div v-if="isUppdated" class="alert alert-warning alert-dismissible fade show mt-5">
        Modificado Exitosamente
        <button
          type="button"
          class="close"
          data-dismiss="alert"
          aria-label="Close"
          @click="deleteMssg"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      
      <!--Tabla que muestra resultados de la búsqueda-->
      <div class="row">
        <div class="table-responsive">
          <table class="table table-striped header table-hover">
            <thead>
              <tr>
                <th scope="col">ID</th>
                <th scope="col">Nombre AC</th>
                <th scope="col">Clientes</th>
                <th scope="col">Monto</th>
                <th scope="col">Banco</th>
                <th scope="col">Fecha desembolso</th>
                <th scope="col">Sucursal</th>
                <th scope="col">Regional</th>
                <th scope="col">Acciones</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in displayedDesembolsos" :key="item.id">
                <th>{{ item.id }}</th>
                <td>{{ item.nombre_ac }}</td>
                <td>{{ item.clientes }}</td>
                <td>{{ item.monto }}</td>
                <td>{{ item.banco }}</td>
                <td>{{ item.fecha_desembolso }}</td>
                <td>{{ item.sucursal }}</td>
                <td>{{ item.regional }}</td>
                <td>
                  <div class="btn-group">
                    <button
                      class="btn btn-outline-dark mr-1"
                      @click="editDesembolso(item.id, item.nombre_ac, item.clientes, item.monto, item.banco, item.fecha_desembolso, item.sucursal, item.regional)"
                    >
                      <i class="far fa-edit"></i>
                    </button>
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>

      <!--     Ciclo para mostrar numero de páginas dentro de un array       -->
      <div class="btn-group col-md-2 offset-md-5">

        <button
          type="button"
          class="btn btn-sm btn-primary"
          v-if="page != 1"
          @click="page--"
          > Prev. </button>
        <button
          type="button"
          class="btn btn-sm btn-primary"
          v-for="pageNumber in pages.slice(page-1, page+5)"
          @click="page = pageNumber"
          :key="pageNumber"
          >{{pageNumber}}</button>
        <button
          type="button"
          @click="page++"
          v-if="page < pages.length"
          class="btn btn-sm btn-primary"
          >>></button>
      </div>

      <!--Formulario para modificar-->
      <form v-if="seen">
        <div class="h2 mt-5 titulo">Modificar Datos</div>
        <!--fila-->
        <div class="form-row">
          <div class="form-group col-md-1">
            <label for="id">ID:</label>
            <input type="text" class="form-control" id="id" v-model="id" disabled />
          </div>
          <div class="form-group col-md-6">
            <label for="nombre_ac">Nombre AC:</label>
            <input type="text" class="form-control" id="nombre_ac" v-model="nombre_ac" required />
            <small id="demo" class="form-text text-danger" v-if="!nombre_ac">*Campo requerido.</small>
          </div>
          <div class="form-group col-md-2">
            <label for="clientes">Clientes:</label>
            <input type="number" class="form-control" id="clientes" v-model="clientes" required />
            <small id="demo" class="form-text text-danger" v-if="!clientes">*Campo requerido.</small>
          </div>
          <div class="form-group col-md-3">
            <label for="monto">Monto:</label>
            <input type="text" class="form-control" id="monto" v-model="monto" required />
            <small id="demo" class="form-text text-danger" v-if="!monto">*Campo requerido.</small>
          </div>
        </div>

        <!--fila-->
        <div class="form-row">
          <div class="form-group col-md-3">
            <label for="banco">Banco:</label>
            <select class="custom-select" name="banco" id="banco" v-model="banco" required>
              <option selected></option>
              <option value="bancomer">BBVA Bancomer</option>
              <option value="banamex">Banamex</option>
            </select>
            <small id="demo" class="form-text text-danger" v-if="!banco">*Campo requerido.</small>
          </div>
          <div class="form-group col-md-4">
            <label for="fecha_desembolso">Desembolso:</label>
            <input
              type="date"
              class="form-control"
              id="fecha_desembolso"
              name="fecha_desembolso"
              v-model="fecha_desembolso"
              required
            />
            <small
              id="demo"
              class="form-text text-danger"
              v-if="!fecha_desembolso"
            >*Campo requerido.</small>
          </div>
          <div class="form-group col-md-3">
            <label for="sucursal">Sucursal:</label>
            <select class="custom-select" name="sucursal" id="sucursal" v-model="sucursal" required>
              <option selected></option>
              <option value="xalapa">Xalapa</option>
              <option value="teziutlan">Teziutlán</option>
              <option value="oaxaca">Oaxaca</option>
              <option value="puebla">Puebla</option>
              <option value="huamantla">Huamantla</option>
            </select>
            <small id="demo" class="form-text text-danger" v-if="!sucursal">*Campo requerido.</small>
          </div>
          <div class="form-group col-md-2">
            <label for="regional">Region:</label>
            <select class="custom-select" name="regional" id="regional" v-model="regional" required>
              <option selected></option>
              <option value="veracruz">Veracruz</option>
              <option value="oaxaca">Oaxaca</option>
              <option value="puebla">Puebla</option>
            </select>
            <small id="demo" class="form-text text-danger" v-if="!regional">*Campo requerido.</small>
          </div>
        </div>
        <button type="button" class="btn btn-primary mb-3" @click="updateDesembolso()">Guardar</button>
      </form>
    </div>

    <!--Footer/Pie de pagina-->
    <Footer></Footer>
  </div>
</template>

<script>
import Footer from "../components/Footer.vue";
import axios from "axios";

export default {
  name: "Modificar",
  components: {
    Footer,
  },
  data() {
    return {
      titulo: "Modificar",
      lista: [],
      id: "",
      nombre_ac: "",
      clientes: "",
      monto: "",
      banco: "",
      fecha_desembolso: "",
      sucursal: "",
      regional: "",
      seen: false,
      isUppdated: false,
      fecha_1: "",
      fecha_2: "",
      selectSucursal: false,
      selectRegional: false,
      page: 1,
      perPage: 3,
      pages: []
    };
  },
  methods: {
    deleteMssg() {
      this.isUppdated = false;
    },

    setLista() {
      let numberOfPages = Math.ceil(this.lista.length / this.perPage);
      for (let i = 1; i <= numberOfPages; i++) {
        this.pages.push(i);
      }
    },

    paginate(lista) {
      let page = this.page;
      let perPage = this.perPage;
      let from = (page * perPage) - perPage;
      let to = (page * perPage);
      return lista.slice(from, to);
    },

    formSucursal: function(){
      this.selectSucursal = true;
      this.selectRegional = false;
      this.fecha_1 = "";
      this.fecha_2 = "";
      this.sucursal = "";
      this.lista = '';
      //console.log(this.lista.length);
      this.pages = [];
      this.page = 1;
    },

    formRegional: function(){
      this.selectRegional = true;
      this.selectSucursal = false;
      this.fecha_1 = "";
      this.fecha_2 = "";
      this.regional = "";
      this.lista = '';
      //console.log(this.lista.length);
      this.pages = [];
      this.page = 1;
    },

    buscarPorRangoFechaSucursal() {
      axios.post('/operaciones/sucursal', {
        fecha_1: this.fecha_1,
        fecha_2: this.fecha_2,
        sucursal: this.sucursal,
      })
      .then((res) => {
        this.lista = res.data;
        this.fecha_1 = this.fecha_1,
        this.fecha_2 = this.fecha_2,
        this.sucursal = this.sucursal,
        console.log(res);
        
      })
      .catch((err) => {
        console.log(err);
      })
    },

    buscarPorRangoFechaRegional() {
      axios
        .post('/operaciones/regional', {
          fecha_1: this.fecha_1,
          fecha_2: this.fecha_2,
          regional: this.regional,
        })
        .then((res) => {
          this.fecha_1 = this.fecha_1,
          this.fecha_2 = this.fecha_2,
          this.regional = this.regional,
          console.log(this.regional);
          console.log(res);
          this.lista = res.data;
        })
        .catch((err) => {
          console.log(err);
        })
    },

    listarDatos() {
      axios
        .get("/operaciones")
        .then((response) => {
          this.lista = response.data;
          //console.log(response)
        })
        .catch((e) => console.log(e));
    },
    editDesembolso: function (
      id,
      nombre_ac,
      clientes,
      monto,
      banco,
      fecha_desembolso,
      sucursal,
      regional
    ) {
      this.seen = !this.seen;
      this.id = id;
      this.nombre_ac = nombre_ac;
      this.clientes = clientes;
      this.monto = monto;
      this.banco = banco;
      //this.fecha_desembolso = fecha_desembolso;
      const fecha = fecha_desembolso;
      const resFecha = fecha.split("T")
      const fecha_formateada = resFecha[0];
      this.fecha = fecha_formateada;
      this.fecha_desembolso = fecha_formateada;
      //const fecha = new Date(fecha_desembolso);
      //var options = { year: "numeric", month: "2-digit", day: "2-digit"};
      //this.fecha = fecha.toLocaleString("es-ES", options);
      this.sucursal = sucursal;
      this.regional = regional;
      //console.log(fecha.toLocaleString("es-ES", options));
      //console.log(fecha_formateada);
    },
    updateDesembolso: function () {
      if (
        this.nombre_ac === "" ||
        this.clientes === "" ||
        this.monto === "" ||
        this.banco === "" ||
        this.fecha_desembolso === "" ||
        this.sucursal === "" ||
        this.regional === ""
      ) {
        this.texto = "***Campo requerido***";
        //console.log("Campos Req");
        document.getElementById("demo").innerHTML = this.texto;
        return false;
      } else {
        axios
          .put(`/operaciones/${this.id}`, {
            nombre_ac: this.nombre_ac,
            clientes: this.clientes,
            monto: this.monto,
            banco: this.banco,
            fecha_desembolso: this.fecha_desembolso,
            sucursal: this.sucursal,
            regional: this.regional,
          })
          .then((res) => {
            this.nombre_ac = "";
            this.clientes = "";
            this.monto = "";
            this.banco = "";
            this.fecha_desembolso = "";
            this.sucursal = "";
            this.regional = "";
            this.seen = !this.seen;
            this.isUppdated = true;
            this.fecha_1 = "";
            this.fecha_2 = "";
            this.lista =  [];
            this.selectSucursal = false,
            this.selectRegional =  false,
            console.log(res);
            this.pages = [];
            this.page = 1;
          })
          .catch((err) => {
            console.log(err);
          });
      }
    },
  },

  watch: {
    lista(){
      this.setLista();
    }
  },

  computed: {
    displayedDesembolsos: function () {
      return this.paginate(this.lista);
    }
  },
};
</script>

<style >
</style>